;================================================
;	LUNAR LANDER E500
;	ver 1.00
;	for XASM 1.3x/1.4x
;	2006.03-
;	by choikyun
;================================================



	org	0be700h
	scope_on
	pre_off
	include DEF.INC
	include	DEFGAME.S



;================================================
;	CODE
;================================================
Start:
	pushu	imr

	pre	32h
	mv	[--u],(0ech)
	pre	32h
	mv	(0ech),0
	mv	(save_sp),s		;X^bN|C^ۑ

	mv	il,4
	sbcl	(bx),(bx)
	mv	a,[(0e6h)+8]
	mv	il,048h
	call	IocsCall		;\JnCZbg
	call	Cls

	call	Credit			;҃NWbg



	;e평
Init:
	mv	(sound),1	;ʉ
	mv	(g_flg),0	;d́F



	;Q[I[o[ăX^[g
Over:
	mvp	(bonus),0
	mvp	(hiscore),[HiScoreBuf]
	mvp	(score),0
	mv	(energy),MAX_ENERGY	;GlM[
	mv	(level),1		;x

	call	Print_SCORE
	mv	(flash),1
	call	DispStatus


	;NAăX^[g
Restart:
	call	InitValue
	call	MakeField		;tB[h쐬
	call	InitEnergy		;GlM[Q[W
	call	Ready



	;C[`
Main:
 {
	call	Inkey			;L[ǂݏo

	call	AddScreen		;XN[
	call	MoveLander		;@ړ
	call	Booster			;@
	call	CheckLanding		;n
	call	CheckLandForm		;n`蔻
	call	DispScreen		;XN[\
	call	AddBonus		;{[iXXRA

	call	Pause			;|[Y
	call	GameOver		;Q[I[o[

	mv	i,60
	call	Wait

	test	(key),KEY_BASIC
	jrz	continue
 }



	;I
Basic:
	mv	s,(save_sp)		;X^bN|C^A
	and	[SCRN_CSR_Y],0		;sZbg

	call	Cls
	call	VerInfo			;o[W\
	pre	32h
	mv	(0ech),[u++]
	popu	imr
	rc
	retf



;------------------------------------------------
;	eϐ
;------------------------------------------------
InitValue:
 {
	mv	il,12
	sbcl	(lander_x),(lander_x)
	mvp	(lander_x),DEF_LANDER_X
	mvp	(lander_y),DEF_LANDER_Y
	mvp	(vx),DEF_X_ACCER		;Xxl

	mv	(over_flg),0			;Q[I[o[tO
	mvp	(bonus),001000h			;{[iX1000_
	ret
 }



;------------------------------------------------
;	GlM[Q[W
;------------------------------------------------
InitEnergy:
 {
	mv	y,FieldBuf+SCREEN_WIDTH
	mv	x,Chr_ENERGY
	mv	ba,1
	mv	il,5
	mv	(work),4
	{
		pushu	y
		pushu	x
		pushu	il
		pushu	ba
		call	PutPattn_SET
		popu	ba
		mv	i,0100h
		add	ba,i
		popu	il
		popu	x
		popu	y

		dec	(work)
		jrnz	continue
	}
	jp	DispEnergy
 }



;------------------------------------------------
;	Q[Jn
;------------------------------------------------
Ready:
 {
	{
		call	Inkey		;L[ǂݏo
		call	AddScreen
		call	DispFlag
		call	Print_LEVEL2
		call	Print_G
		call	Print_PUSH
		call	Print_SE
		call	DispScreen	;XN[\
		test	(keyf),KEY_BASIC
		jrnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	call	AddScreen
	call	DispFlag
	call	DispScreen
	mv	x,Sound1
	call	Se
	mv	i,500
	jp	Wait
 }



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
 {
	{
		test	(keyf),KEY_SHIFT
		jrnz	break
		ret
	}
	mv	x,Sound1
	call	Se
	{
		call	Inkey		;L[ǂݏo

		call	Print_G		;d͕\
		call	Print_SE	;ʉ؂芷
		call	Print_PAUSE	;bZ[W
		call	DispScreen	;XN[\

		test	(keyf),KEY_BASIC
		jrnz	Basic
		test	(keyf),KEY_SHIFT
		jrz	continue
	}
	mv	x,Sound1
	jp	Se
 }



	;Tu
Print_PAUSE:
 {
	mv	y,ScreenBuf
	mv	x,Mes_PAUSE
	mv	il,21
	mv	ba,4*256+98	;(98,4)
	jp	PutPattn_SET
 }



Print_SE:
 {
	{
		test	(keyf),KEY_CCE
		jrz	break
		xor	(sound),1
		mv	x,Sound1
		call	Se
	}
	mv	y,ScreenBuf
	mv	x,Mes_SOUND
	mv	il,21
	mv	ba,1*256+86	;(0,1)
	call	PutPattn_SET

	mv	y,ScreenBuf
	mv	x,Mes_SOUND+21
	mv	a,(sound)
	swap	a
	add	x,a
	mv	ba,1*256+107
	mv	il,13
	jp	PutPattn_SET
 }



Print_G:
 {
	{
		test	(keyf),KEY_8
		jrz	break
		xor	(g_flg),1
		mv	x,Sound1
		call	Se
	}
	mv	y,ScreenBuf
	mv	x,Mes_G+19
	mv	il,19
	{
		test	(g_flg),1
		jrnz	break
		mv	x,Mes_G
	}
	mv	ba,1*256+0
	jp	PutPattn_SET
 }



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
GameOver:
 {
	{
		cmp	(over_flg),0
		jrnz	break
		ret
	}
;	mv	i,60
;	call	Wait
	{
		test	(over_flg),FLG_CLEAR	;NA
		jrz	break
		mv	x,Sound5
		call	Se
		call	Print_CLEAR
		{
			cmp	(level),8
			jrnc	break
			inc	(level)
		}
		mv	(flash),1
		{
			call	Inkey		;L[ǂݏo
			call	Print_PUSH
			call	DispStatus
			call	DispScreen	;XN[\
			test	(keyf),KEY_BASIC
			jpnz	Basic
			test	(keyf),KEY_SPACE
			jrz	continue
		}
		mv	x,Sound1
		call	Se
		pops	i
		jp	ReStart
	}
	mv	x,Sound4			;Q[I[o[
	call	Se
	call	AddScreen
	call	Crash
	call	DispScreen
	mv	i,350
	call	Wait
	call	Print_OVER
	call	Print_HISCORE
	mv	(flash),1
	{
		call	Inkey		;L[ǂݏo
		call	Print_PUSH
		call	DispStatus
		call	DispScreen	;XN[\

		test	(keyf),KEY_BASIC
		jpnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	mv	x,Sound1
	call	Se
	pops	i
	jp	Over
 }



	;Tu
Print_CLEAR:
 {
	mv	y,ScreenBuf
	mv	x,Mes_CLEAR
	mv	il,48
	mv	ba,1*256+36	;(36,1)
	call	PutPattn_SET
	call	Print_LEVEL	;x\
	call	Print_BONUS	;{[iXXRA\
	jp	Print_SCORE	;EʃXRA\
	}


Print_OVER:
 {
	call	Print_LEVEL3	;x\
	mv	y,ScreenBuf
	mv	x,Mes_OVER
	mv	il,34
	mv	ba,2*256+43	;(43,2)
	jp	PutPattn_SET
 }


Print_PUSH:
 {
	mv	y,ScreenBuf
	mv	x,Mes_PUSH
	mv	il,59
	mv	ba,4*256+61	;(61,4)
	jp	PutPattn_SET
 }


Crash:
 {
	call	DivScale
	ex	a,b
	dec	a
	ex	a,b
	mv	y,ScreenBuf
	mv	x,Chr_CRASH
	jp	Gput
 }



;------------------------------------------------
;	GlM[Q[W\
;------------------------------------------------
DispEnergy:
 {
	mv	a,(energy)
	and	a,1111_1100b
	ror	a
	ror	a
	mv	(work),a
	mv	a,31
	sub	a,(work)
	mv	(work),a
	{
		cmp	(work),0
		jrz	break
		dec	(work)
		mv	a,(work)
		mv	b,a
		mv	a,2
;		mv	y,FieldBuf+SCREEN_WIDTH
		call	Preset
		jr	continue
	}
	ret
 }



;------------------------------------------------
;	u[X^[
;------------------------------------------------
Booster:
 {
	{
		cmp	(energy),0
		jrnz	break
		ret
	}
	{
		test	(key),KEY_SPACE
		jrz	break
		{
			call	DivScale	;ʂ͂ݏo瑀s\
			mv	a,b
			cmp	a,4
			jrnc	break
			mvp	(vy),0
			ret
		}
		mv	x,(vy)
		mv	y,BOOST_POWER
		sub	x,y
		mv	(vy),x

		call	DivScale	;\
		ex	a,b
		add	a,5
		ex	a,b
		mv	x,Chr_BOOST
		call	Gput
		{
			sub	(energy),MAIN_ENERGY	;GlM[
			jrnc	break
			mv	(energy),0
		}
		call	DispEnergy		;GlM[\
		mv	x,Sound1
		jp	Se
	}
	{
		test	(key),KEY_4	;u[X^[
		jrz	break
		{
			call	DivScale	;ʂ͂ݏo瑀s\
			cmp	a,SCREEN_WIDTH-8-5
			jrc	break
			mvp	(vx),0
			ret
		}
		mv	x,(vx)
		mv	y,SIDE_POWER
		add	x,y
		mv	(vx),x

		call	DivScale	;\
		sub	a,4
		mv	x,Chr_BOOST+8
		call	Gput
		{
			sub	(energy),SIDE_ENERGY
			jrnc	break
			mv	(energy),0
		}
		call	DispEnergy		;GlM[\
		mv	x,Sound1
		jp	Se
	}
	{
		test	(key),KEY_6	;Eu[X^[
		jrz	break
		{
			call	DivScale	;ʂ͂ݏo瑀s\
			cmp	a,5
			jrnc	break
			mvp	(vx),0
			ret
		}
		mv	x,(vx)
		mv	y,SIDE_POWER
		sub	x,y
		mv	(vx),x

		call	DivScale	;\
		add	a,9
		mv	x,Chr_BOOST+16
		call	Gput
		{
			sub	(energy),SIDE_ENERGY
			jrnc	break
			mv	(energy),0
		}
		call	DispEnergy		;GlM[\
		mv	x,Sound1
		jp	Se
	}
	ret
 }



;------------------------------------------------
;	@ړ
;------------------------------------------------
MoveLander:
 {
	{
		cmp	(over_flg),0
		jrz	break
		ret
	}
	mv	x,(vx)			;Xx
	mv	y,(lander_x)
	add	y,x
	{
		{
			mv	(work),y	;x>7ɂȂ悤
			mv	x,7000
			cmpp	(work),x
			jrnc	break
			mvp	(vx),0
			mv	y,8000
		}
		{
			mv	x,114000	;x<114ɂȂ悤
			cmpp	(work),x
			jrc	break
			mvp	(vx),0
			mv	y,114000
		}
	}
	mv	(lander_x),y

	mv	x,(vy)			;Yx
	mv	y,(lander_y)
	add	y,x
	{
		mv	(work),y
		test	(work+2),0000_1000b	;ŏbit
		jrz	break
		mv	y,1000
		mvp	(vy),0
	}
	mv	(lander_y),y

	call	AddGravity		;d́@Y
	call	DivScale		;WXP[ϊ@1/1000
	mv	x,Chr_LANDER
	jp	GPut
 }



;------------------------------------------------
;	WXP[ϊ
;	OUT:	ba	1/1000W
;------------------------------------------------
DivScale:
 {
	mv	x,(lander_y)
	mv	y,XY_SCALE
	mv	ba,0
	{
		sub	x,y
		jrc	break
		inc	a
		jr	continue
	}
	ex	a,b
	mv	x,(lander_x)
	{
		sub	x,y
		jrc	break
		inc	a
		jr	continue
	}
	ret
 }



;------------------------------------------------
;	d͉
;------------------------------------------------
AddGravity:
 {
	mv	x,(vy)		;Yx
	mv	y,MOON_G	;d
	{
		test	(g_flg),1
		jrz	break
		mv	y,JUPITER_G	;ؐd
	}
	add	x,y
	mv	(vy),x
	ret
 }



;------------------------------------------------
;	n`蔻
;------------------------------------------------
CheckLandForm:
 {
	call	DivScale
	mv	x,Check_LANDER

	mv	y,FieldBuf
	call	GetPosition

	mv	(_PX),work
	{
		mv	il,[x++]
		pre	36h
		mv	(0),i
		add	(_PX),2
		cmp	(_PX),work+2*CHR_SIZE
		jrnz	continue
	}
	{
		and	a,7
		jrz	break
		{
			mv	il,2*CHR_SIZE
			adcl	(work),(work)
			dec	a
			jrnz	continue
		}
	}
	mv	(_PX),work
	{
		mv	a,[y+SCREEN_WIDTH]
		pre	36h
		and	a,(1)
		jrnz	break
		mv	a,[y++]
		pre	36h
		and	a,(0)
		jrnz	break

		add	(_PX),2
		cmp	(_PX),work+2*CHR_SIZE
		jrnz	continue
		ret
	}
	mv	(over_flg),FLG_OVER
	ret
 }



;------------------------------------------------
;	`FbN
;------------------------------------------------
CheckLanding:
 {
	call	DivScale
	ex	a,b
	mv	(work),(goal_y)
	sub	(work),7
	{
		cmp	(work),a	;YW`FbN
		jrnc	break
		{
			mv	a,b
			add	a,7		;mx-ex+a<a+b+1
			sub	a,(goal_x)
			mv	(work),(goal_width)
			add	(work),7
			cmp	(work),a
			jrc	break
			{
				mv	x,CLEAR_VY
				cmpp	(vy),x
				jrnc	break
				{
					mv	x,GOOD_VY
					cmpp	(vy),x
					jrnc	break
					or	(over_flg),FLG_GOOD;GOOD!
				}
				{
					mv	x,CLEAR_VX_MIN
					cmpp	(vx),x
					jrnc	break
					or	(over_flg),FLG_CLEAR
					ret
				}
				{
					mv	x,CLEAR_VX_MAX
					cmpp	(vx),x
					jrc	break
					or	(over_flg),FLG_CLEAR
				}
				ret
			}
		}
	}
	ret
 }



;------------------------------------------------
;	XN[obt@
;------------------------------------------------
AddScreen:
 {
	mv	x,ScreenBuf+SCREEN_WIDTH
	mv	y,FieldBuf+SCREEN_WIDTH
	mv	a,4
	{
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		dec	a
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	\
;------------------------------------------------
DispFlag:
 {
	mv	a,(goal_y)
	sub	a,5
	mv	b,a
	mv	a,(goal_width)
	ror	a
	add	a,(goal_x)
	mv	x,Chr_FLAG
	jp	Gput
 }



;------------------------------------------------
;	n`쐬
;------------------------------------------------
MakeField:
 {
	mv	y,FieldBuf		;obt@̃NA
	mv	i,SCREEN_WIDTH*SCREEN_HEIGHT/2
	mv	ba,0
	{
		mv	[y++],ba
		dec	i
		jrnz	continue
	}
	mv	(goal_width),MAX_GOAL_WIDTH	;n_̕
	mv	a,(level)
	add	a,a
	add	a,a
	sub	(goal_width),a
	mv	a,(goal_width)
	mv	(work),118
	sub	(work),a
	{
		call	Rnd		;S[쐬
		and	a,127		;
		add	a,8		;GlM[Q[W
		mv	(work+1),a
		cmp	(work+1),(work)
		jrnc	continue
	}
	mv	(goal_x),a		;n_XW

	call	Rnd			;_YW
	and	a,15
	add	a,16+8
	mv	(goal_y),a

	mv	(work),(goal_width)
	mv	ba,(goal_x)
	{
		pushu	ba
		call	Pset
		popu	ba
		inc	a

		dec	(work)
		jrnz	continue
	}



;EŐ㏸Ȑ
	mv	(work+5),1			;
	mv	(work+1),(goal_x)		;Xl
	mv	(work+2),(goal_y)		;Yl
DrawEggLine:
	{
		cmp	(work+1),5	;x>5
		jrc	break
		cmp	(work+2),5+8	;y>5
		jrc	break
		{
			dec	(work+5)
			jrnz	break
			call	Rnd
			and	a,3
			add	a,3
			mv	(work+5),a
			{
				call	Rnd	;Ő@X4p^[
				and	a,3
				mv	(work),a	;X΃p^[
			}
		}
		{
			cmp	(work),0
			jrnz	break
			dec	(work+1)		;1,1
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),1
			jrnz	break
			dec	(work+1)		;2,1
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
			dec	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),2
			jrnz	break
			dec	(work+1)		;1,2
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),3
			jrnz	break
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
			inc	(work+1)		;-1,2
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		jr	continue
	}
	{
		cmp	(work),3
		jrnz	break
		dec	(work+2)
		mv	ba,(work+1)
		call	Pset
	}
	call	Rnd
	and	a,7
	add	a,1
	mv	(work+5),a
	{
		dec	(work+5)
		jrz	break
		cmp	(work+1),5	; x>5
		jrc	break

		dec	(work+1)
		mv	ba,(work+1)
		call	Pset
		jr	continue
	}


;Ő~Ȑ
	mv	(work+5),1
	{
		cmp	(work+1),5		;x>5
		jrc	break
		cmp	(work+2),31+8		;y>31
		jrnc	break
		{
			dec	(work+5)
			jrnz	break
			call	Rnd
			and	a,3
			add	a,3
			mv	(work+5),a
			{
				call	Rnd	;Ő@X3p^[
				and	a,3
				jrz	continue
				dec	a
				mv	(work),a	;X΃p^[
			}
		}
		{
			cmp	(work),0
			jrnz	break
			dec	(work+1)		;1,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),1
			jrnz	break
			dec	(work+1)		;2,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset
			dec	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),2
			jrnz	break
			dec	(work+1)		;3,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset
			dec	(work+1)
			mv	ba,(work+1)
			call	Pset
			dec	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		jr	continue
	}
	call	Rnd
	and	a,7
	add	a,1
	mv	(work+5),a
	{
		dec	(work+5)
		jrz	break
		cmp	(work+1),5	; x>5
		jrc	break
		dec	(work+1)
		mv	ba,(work+1)
		call	Pset
		jr	continue
	}
	cmp	(work+1),5
	jpnc	DrawEggLine



;ŐE
	mv	(work+5),1		;
	mv	(work+1),(goal_x)
	mv	a,(goal_width)
	dec	a
	add	(work+1),a		;Xl
	mv	(work+2),(goal_y)	;Yl
DrawEggLine2:
	{
		cmp	(work+1),120		;x>120
		jrnc	break
		cmp	(work+2),5+8		;y>5
		jrc	break
		{
			dec	(work+5)
			jrnz	break
			call	Rnd
			and	a,3
			add	a,3
			mv	(work+5),a
			{
				call	Rnd		;ŐE@X4p^[
				and	a,3
				mv	(work),a	;X΃p^[
			}
		}
		{
			cmp	(work),0
			jrnz	break
			inc	(work+1)		;1,1
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),1
			jrnz	break
			inc	(work+1)		;2,1
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
			inc	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),2
			jrnz	break
			inc	(work+1)		;1,2
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),3
			jrnz	break
			dec	(work+2)		;-1,2
			mv	ba,(work+1)
			call	Pset
			dec	(work+1)
			dec	(work+2)
			mv	ba,(work+1)
			call	Pset

		}
		jr	continue
	}
	{
		cmp	(work),3
		jrnz	break
		dec	(work+2)
		mv	ba,(work+1)
		call	Pset
	}
	call	Rnd
	and	a,7
	add	a,1
	mv	(work+5),a
	{
		dec	(work+5)
		jrz	break
		cmp	(work+1),120			;
		jrnc	break
		inc	(work+1)
		mv	ba,(work+1)
		call	Pset
		jr	continue
	}
;EŐ~Ȑ
	mv	(work+5),1
	{
		cmp	(work+1),120		;x>120
		jrnc	break
		cmp	(work+2),31+8		;y>31
		jrnc	break
		{
			dec	(work+5)
			jrnz	break
			call	Rnd
			and	a,3
			add	a,3
			mv	(work+5),a
			{
				call	Rnd	;Ő@X3p^[
				and	a,3
				jrz	continue
				dec	a
				mv	(work),a	;X΃p^[
			}
		}
		{
			cmp	(work),0
			jrnz	break
			inc	(work+1)		;1,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset

		}
		{
			cmp	(work),1
			jrnz	break
			inc	(work+1)		;2,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset
			inc	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		{
			cmp	(work),2
			jrnz	break
			inc	(work+1)		;3,1
			inc	(work+2)
			mv	ba,(work+1)
			call	Pset
			inc	(work+1)
			mv	ba,(work+1)
			call	Pset
			inc	(work+1)
			mv	ba,(work+1)
			call	Pset
		}
		jr	continue
	}
	call	Rnd
	and	a,7
	add	a,1
	mv	(work+5),a
	{
		dec	(work+5)
		jrz	break
		cmp	(work+1),120	; x>120
		jrnc	break
		inc	(work+1)
		mv	ba,(work+1)
		call	Pset
		jr	continue
	}
	cmp	(work+1),120
	jpc	DrawEggLine2

	ret
 }



	include		VER.S		;o[W

	include		LIB.S		;ėpCu
	include		SCORE.S		;XRA

	include		DATA.S		;f[^
	include		WORK.S		;[N



	end
